Index: branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Algorithms.NSGA2/3.3/NSGA2.cs
===================================================================
--- branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Algorithms.NSGA2/3.3/NSGA2.cs	(revision 12190)
+++ branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Algorithms.NSGA2/3.3/NSGA2.cs	(revision 12247)
@@ -88,4 +88,8 @@
       get { return (ValueParameter<IntValue>)Parameters["SelectedParents"]; }
     }
+
+    private IFixedValueParameter<BoolValue> DominateOnEqualQualitiesParameter {
+      get { return (IFixedValueParameter<BoolValue>)Parameters["DominateOnEqualQualities"]; }
+    }
     #endregion
 
@@ -135,4 +139,9 @@
       set { SelectedParentsParameter.Value = value; }
     }
+    public bool DominateOnEqualQualities {
+      get { return DominateOnEqualQualitiesParameter.Value.Value; }
+      set { DominateOnEqualQualitiesParameter.Value.Value = value; }
+    }
+
     private RandomCreator RandomCreator {
       get { return (RandomCreator)OperatorGraph.InitialOperator; }
@@ -171,4 +180,5 @@
       Parameters.Add(new ValueParameter<IntValue>("MaximumGenerations", "The maximum number of generations which should be processed.", new IntValue(1000)));
       Parameters.Add(new ValueParameter<IntValue>("SelectedParents", "Each two parents form a new child, typically this value should be twice the population size, but because the NSGA-II is maximally elitist it can be any multiple of 2 greater than 0.", new IntValue(200)));
+      Parameters.Add(new FixedValueParameter<BoolValue>("DominateOnEqualQualities", "Flag which determines wether solutions with equal quality values should be treated as dominated.", new BoolValue(false)));
 
       RandomCreator randomCreator = new RandomCreator();
@@ -195,4 +205,5 @@
       subScopesCounter.Successor = rankAndCrowdingSorter;
 
+      rankAndCrowdingSorter.DominateOnEqualQualitiesParameter.ActualName = DominateOnEqualQualitiesParameter.Name;
       rankAndCrowdingSorter.CrowdingDistanceParameter.ActualName = "CrowdingDistance";
       rankAndCrowdingSorter.RankParameter.ActualName = "Rank";
@@ -311,4 +322,10 @@
     [StorableHook(HookType.AfterDeserialization)]
     private void AfterDeserialization() {
+      // BackwardsCompatibility3.3
+      #region Backwards compatible code, remove with 3.4
+      if (!Parameters.ContainsKey("DominateOnEqualQualities"))
+        Parameters.Add(new FixedValueParameter<BoolValue>("DominateOnEqualQualities", "Flag which determines wether solutions with equal quality values should be treated as dominated.", new BoolValue(false)));
+      #endregion
+
       PopulationSizeParameter.ValueChanged += new EventHandler(PopulationSizeParameter_ValueChanged);
       PopulationSize.ValueChanged += new EventHandler(PopulationSize_ValueChanged);
Index: branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Algorithms.NSGA2/3.3/NSGA2MainLoop.cs
===================================================================
--- branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Algorithms.NSGA2/3.3/NSGA2MainLoop.cs	(revision 12190)
+++ branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Algorithms.NSGA2/3.3/NSGA2MainLoop.cs	(revision 12247)
@@ -79,8 +79,20 @@
       get { return (LookupParameter<IntValue>)Parameters["EvaluatedSolutions"]; }
     }
+    public IValueLookupParameter<BoolValue> DominateOnEqualQualitiesParameter {
+      get { return (ValueLookupParameter<BoolValue>)Parameters["DominateOnEqualQualities"]; }
+    }
     #endregion
 
     [StorableConstructor]
     protected NSGA2MainLoop(bool deserializing) : base(deserializing) { }
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      // BackwardsCompatibility3.3
+      #region Backwards compatible code, remove with 3.4
+      if (!Parameters.ContainsKey("DominateOnEqualQualities"))
+        Parameters.Add(new ValueLookupParameter<BoolValue>("DominateOnEqualQualities", "Flag which determines wether solutions with equal quality values should be treated as dominated."));
+      #endregion
+    }
+
     protected NSGA2MainLoop(NSGA2MainLoop original, Cloner cloner) : base(original, cloner) { }
     public NSGA2MainLoop()
@@ -105,4 +117,5 @@
       Parameters.Add(new ValueLookupParameter<IOperator>("Analyzer", "The operator used to analyze each generation."));
       Parameters.Add(new LookupParameter<IntValue>("EvaluatedSolutions", "The number of times solutions have been evaluated."));
+      Parameters.Add(new ValueLookupParameter<BoolValue>("DominateOnEqualQualities", "Flag which determines wether solutions with equal quality values should be treated as dominated."));
       #endregion
 
@@ -171,4 +184,5 @@
       subScopesCounter.ValueParameter.ActualName = EvaluatedSolutionsParameter.Name;
 
+      rankAndCrowdingSorter.DominateOnEqualQualitiesParameter.ActualName = DominateOnEqualQualitiesParameter.Name;
       rankAndCrowdingSorter.CrowdingDistanceParameter.ActualName = "CrowdingDistance";
       rankAndCrowdingSorter.RankParameter.ActualName = "Rank";
Index: branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Algorithms.RAPGA/3.3/RAPGA.cs
===================================================================
--- branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Algorithms.RAPGA/3.3/RAPGA.cs	(revision 12190)
+++ branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Algorithms.RAPGA/3.3/RAPGA.cs	(revision 12247)
@@ -510,8 +510,10 @@
         SimilarityCalculatorParameter.ValidValues.Add(similarityCalculator);
 
-      if (!SimilarityCalculatorParameter.ValidValues.Any()) {
-        SimilarityCalculatorParameter.ValidValues.Add(new QualitySimilarityCalculator { QualityVariableName = Problem.Evaluator.QualityParameter.ActualName });
+      if (!SimilarityCalculatorParameter.ValidValues.OfType<QualitySimilarityCalculator>().Any())
+        SimilarityCalculatorParameter.ValidValues.Add(new QualitySimilarityCalculator {
+          QualityVariableName = Problem.Evaluator.QualityParameter.ActualName
+        });
+      if (!SimilarityCalculatorParameter.ValidValues.OfType<NoSimilarityCalculator>().Any())
         SimilarityCalculatorParameter.ValidValues.Add(new NoSimilarityCalculator());
-      }
 
       if (oldSimilarityCalculator != null) {
Index: branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Algorithms.ScatterSearch/3.3/ScatterSearch.cs
===================================================================
--- branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Algorithms.ScatterSearch/3.3/ScatterSearch.cs	(revision 12190)
+++ branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Algorithms.ScatterSearch/3.3/ScatterSearch.cs	(revision 12247)
@@ -410,8 +410,10 @@
         SimilarityCalculatorParameter.ValidValues.Add(similarityCalculator);
 
-      if (!SimilarityCalculatorParameter.ValidValues.Any()) {
-        SimilarityCalculatorParameter.ValidValues.Add(new QualitySimilarityCalculator { QualityVariableName = Problem.Evaluator.QualityParameter.ActualName });
+      if (!SimilarityCalculatorParameter.ValidValues.OfType<QualitySimilarityCalculator>().Any())
+        SimilarityCalculatorParameter.ValidValues.Add(new QualitySimilarityCalculator {
+          QualityVariableName = Problem.Evaluator.QualityParameter.ActualName
+        });
+      if (!SimilarityCalculatorParameter.ValidValues.OfType<NoSimilarityCalculator>().Any())
         SimilarityCalculatorParameter.ValidValues.Add(new NoSimilarityCalculator());
-      }
 
       if (oldSimilarityCalculator != null) {
Index: branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Analysis.Statistics.Views/3.3/ChartAnalysisView.cs
===================================================================
--- branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Analysis.Statistics.Views/3.3/ChartAnalysisView.cs	(revision 12190)
+++ branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Analysis.Statistics.Views/3.3/ChartAnalysisView.cs	(revision 12247)
@@ -112,5 +112,7 @@
 
     void Content_ColumnsChanged(object sender, EventArgs e) {
-      RebuildDataTableAsync();
+      if (!suppressUpdates) {
+        RebuildDataTableAsync();
+      }
     }
 
@@ -289,8 +291,8 @@
         double percentile25 = values.Percentile(0.25);
         double percentile75 = values.Percentile(0.75);
-        double lowerAvg = values.OrderBy(x => x).Take((int)(values.Count() * 0.25)).Average();
-        double upperAvg = values.OrderByDescending(x => x).Take((int)(values.Count() * 0.25)).Average();
-        double firstAvg = values.Take((int)(values.Count() * 0.25)).Average();
-        double lastAvg = values.Skip((int)(values.Count() * 0.75)).Average();
+        double lowerAvg = values.Count() > 4 ? values.OrderBy(x => x).Take((int)(values.Count() * 0.25)).Average() : double.NaN;
+        double upperAvg = values.Count() > 4 ? values.OrderByDescending(x => x).Take((int)(values.Count() * 0.25)).Average() : double.NaN;
+        double firstAvg = values.Count() > 4 ? values.Take((int)(values.Count() * 0.25)).Average() : double.NaN;
+        double lastAvg = values.Count() > 4 ? values.Skip((int)(values.Count() * 0.75)).Average() : double.NaN;
         double slope, intercept, r;
         llsFitting.Calculate(values, out slope, out intercept);
Index: branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Analysis.Statistics.Views/3.3/CorrelationView.cs
===================================================================
--- branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Analysis.Statistics.Views/3.3/CorrelationView.cs	(revision 12190)
+++ branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Analysis.Statistics.Views/3.3/CorrelationView.cs	(revision 12247)
@@ -56,4 +56,5 @@
       stringConvertibleMatrixView.Minimum = -1.0;
       stringConvertibleMatrixView.Maximum = 1.0;
+      stringConvertibleMatrixView.FormatPattern = "0.000";
 
       methodComboBox.Items.Add(PearsonName);
@@ -97,5 +98,7 @@
 
     void Content_ColumnsChanged(object sender, EventArgs e) {
-      UpdateUI();
+      if (!suppressUpdates) {
+        UpdateUI();
+      }
     }
 
@@ -212,6 +215,8 @@
                 .Where(x => !double.IsNaN(x) && !double.IsNegativeInfinity(x) && !double.IsPositiveInfinity(x));
 
-          if (!rowValues.Any() || !columnValues.Any() || i == j || rowValues.Count() != columnValues.Count()) {
+          if (!rowValues.Any() || !columnValues.Any() || rowValues.Count() != columnValues.Count()) {
             dt[i, j] = double.NaN;
+          } else if (i == j) {
+            dt[i, j] = 1.0;
           } else {
             if (methodName == PearsonName) {
Index: branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Analysis.Statistics.Views/3.3/SampleSizeInfluenceView.cs
===================================================================
--- branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Analysis.Statistics.Views/3.3/SampleSizeInfluenceView.cs	(revision 12190)
+++ branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Analysis.Statistics.Views/3.3/SampleSizeInfluenceView.cs	(revision 12247)
@@ -174,5 +174,7 @@
         Invoke(new EventHandler(Content_ColumnNamesChanged), sender, e);
       else {
-        UpdateComboBoxes();
+        if (!suppressUpdates) {
+          UpdateComboBoxes();
+        }
       }
     }
Index: branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Analysis.Statistics.Views/3.3/StatisticalTestsView.cs
===================================================================
--- branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Analysis.Statistics.Views/3.3/StatisticalTestsView.cs	(revision 12190)
+++ branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Analysis.Statistics.Views/3.3/StatisticalTestsView.cs	(revision 12247)
@@ -109,5 +109,7 @@
 
     void Content_ColumnsChanged(object sender, EventArgs e) {
-      RebuildDataTable();
+      if (!Content.UpdateOfRunsInProgress) {
+        RebuildDataTable();
+      }
     }
 
@@ -277,5 +279,5 @@
 
       //alglib needs at least 5 samples for computation
-      if (data.Any(x => x.Length <= requiredSampleSize)) {
+      if (data.Any(x => x.Length < requiredSampleSize)) {
         if (showMessage)
           MessageBox.Show(this, "You need at least " + requiredSampleSize
@@ -291,5 +293,5 @@
         return;
 
-      if (data != null) {
+      if (data != null && data.All(x => x != null)) {
         MainFormManager.GetMainForm<HeuristicLab.MainForm.WindowsForms.MainForm>()
           .AddOperationProgressToView(this, "Calculating...");
Index: branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Analysis.Views/3.3/HistogramControl.Designer.cs
===================================================================
--- branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Analysis.Views/3.3/HistogramControl.Designer.cs	(revision 12190)
+++ branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Analysis.Views/3.3/HistogramControl.Designer.cs	(revision 12247)
@@ -55,12 +55,15 @@
       this.label1 = new System.Windows.Forms.Label();
       this.exactCheckBox = new System.Windows.Forms.CheckBox();
+      this.label2 = new System.Windows.Forms.Label();
+      this.bandwidthNumericUpDown = new System.Windows.Forms.NumericUpDown();
       ((System.ComponentModel.ISupportInitialize)(this.chart)).BeginInit();
       ((System.ComponentModel.ISupportInitialize)(this.binsNumericUpDown)).BeginInit();
+      ((System.ComponentModel.ISupportInitialize)(this.bandwidthNumericUpDown)).BeginInit();
       this.SuspendLayout();
       // 
       // chart
       // 
-      this.chart.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-            | System.Windows.Forms.AnchorStyles.Left)
+      this.chart.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
       chartArea1.Name = "ChartArea1";
@@ -88,5 +91,5 @@
             0});
       this.binsNumericUpDown.Minimum = new decimal(new int[] {
-            1,
+            2,
             0,
             0,
@@ -115,5 +118,5 @@
       this.exactCheckBox.AutoSize = true;
       this.exactCheckBox.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
-      this.exactCheckBox.Location = new System.Drawing.Point(158, 4);
+      this.exactCheckBox.Location = new System.Drawing.Point(291, 4);
       this.exactCheckBox.Name = "exactCheckBox";
       this.exactCheckBox.Size = new System.Drawing.Size(56, 17);
@@ -123,7 +126,42 @@
       this.exactCheckBox.CheckedChanged += new System.EventHandler(this.exactCheckBox_CheckedChanged);
       // 
+      // label2
+      // 
+      this.label2.AutoSize = true;
+      this.label2.Location = new System.Drawing.Point(158, 5);
+      this.label2.Name = "label2";
+      this.label2.Size = new System.Drawing.Size(60, 13);
+      this.label2.TabIndex = 5;
+      this.label2.Text = "Bandwidth:";
+      // 
+      // bandwidthNumericUpDown
+      // 
+      this.bandwidthNumericUpDown.DecimalPlaces = 2;
+      this.bandwidthNumericUpDown.Location = new System.Drawing.Point(224, 3);
+      this.bandwidthNumericUpDown.Maximum = new decimal(new int[] {
+            100000000,
+            0,
+            0,
+            0});
+      this.bandwidthNumericUpDown.Minimum = new decimal(new int[] {
+            1,
+            0,
+            0,
+            851968});
+      this.bandwidthNumericUpDown.Name = "bandwidthNumericUpDown";
+      this.bandwidthNumericUpDown.Size = new System.Drawing.Size(61, 20);
+      this.bandwidthNumericUpDown.TabIndex = 4;
+      this.bandwidthNumericUpDown.Value = new decimal(new int[] {
+            1,
+            0,
+            0,
+            0});
+      this.bandwidthNumericUpDown.ValueChanged += new System.EventHandler(this.bandwidthNumericUpDown_ValueChanged);
+      // 
       // HistogramControl
       // 
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
+      this.Controls.Add(this.label2);
+      this.Controls.Add(this.bandwidthNumericUpDown);
       this.Controls.Add(this.exactCheckBox);
       this.Controls.Add(this.label1);
@@ -134,4 +172,5 @@
       ((System.ComponentModel.ISupportInitialize)(this.chart)).EndInit();
       ((System.ComponentModel.ISupportInitialize)(this.binsNumericUpDown)).EndInit();
+      ((System.ComponentModel.ISupportInitialize)(this.bandwidthNumericUpDown)).EndInit();
       this.ResumeLayout(false);
       this.PerformLayout();
@@ -145,4 +184,6 @@
     private System.Windows.Forms.Label label1;
     private System.Windows.Forms.CheckBox exactCheckBox;
+    private System.Windows.Forms.Label label2;
+    private System.Windows.Forms.NumericUpDown bandwidthNumericUpDown;
   }
 }
Index: branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Analysis.Views/3.3/HistogramControl.cs
===================================================================
--- branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Analysis.Views/3.3/HistogramControl.cs	(revision 12190)
+++ branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Analysis.Views/3.3/HistogramControl.cs	(revision 12247)
@@ -31,6 +31,8 @@
   public partial class HistogramControl : UserControl {
     protected static readonly string SeriesName = "Histogram";
-
+    protected static readonly decimal bandwidthMin = 0.0000000000001m;
     protected Dictionary<string, List<double>> points;
+    protected bool suppressUpdate;
+
     public int NumberOfBins {
       get { return (int)binsNumericUpDown.Value; }
@@ -123,7 +125,7 @@
     }
 
-    protected void UpdateHistogram() {
+    protected void UpdateHistogram(double bandwith = double.NaN) {
       if (InvokeRequired) {
-        Invoke((Action)UpdateHistogram, null);
+        Invoke((Action<double>)UpdateHistogram, bandwith);
         return;
       }
@@ -134,5 +136,4 @@
 
       chart.Series.Clear();
-
       foreach (var point in points) {
         if (!point.Value.Any()) continue;
@@ -140,5 +141,4 @@
         Series histogramSeries = new Series(point.Key);
         chart.Series.Add(histogramSeries);
-
         double minValue = point.Value.Min();
         double maxValue = point.Value.Max();
@@ -165,11 +165,15 @@
         histogramSeries["PointWidth"] = "1";
 
-        CalculateDensity(histogramSeries, point.Value);
-
         overallMax = Math.Max(overallMax, maxValue);
         overallMin = Math.Min(overallMin, minValue);
+
+        chart.ApplyPaletteColors();
+        CalculateDensity(histogramSeries, point.Value, bandwith);
       }
 
       ChartArea chartArea = chart.ChartAreas[0];
+      // don't show grid lines for second y-axis
+      chartArea.AxisY2.MajorGrid.Enabled = false;
+      chartArea.AxisY2.MinorGrid.Enabled = false;
       chartArea.AxisY.Title = "Frequency";
 
@@ -182,7 +186,8 @@
     }
 
-    protected void CalculateDensity(Series series, List<double> row) {
+    protected void CalculateDensity(Series series, List<double> row, double bandwidth = double.NaN) {
       string densitySeriesName = "Density " + series.Name;
       double stepWidth = series.Points[1].XValue - series.Points[0].XValue;
+      var rowArray = row.ToArray();
 
       if (chart.Series.Any(x => x.Name == densitySeriesName)) {
@@ -191,7 +196,18 @@
       }
 
-      var density = NormalDistribution.Density(row.ToArray(), row.Count, stepWidth);
+      if (double.IsNaN(bandwidth)) {
+        bandwidth = KernelDensityEstimator.EstimateBandwidth(rowArray);
+        decimal bwDecimal = (decimal)bandwidth;
+        if (bwDecimal < bandwidthMin) {
+          bwDecimal = bandwidthMin;
+          bandwidth = decimal.ToDouble(bwDecimal);
+        }
+        suppressUpdate = true;
+        bandwidthNumericUpDown.Value = bwDecimal;
+      }
+      var density = KernelDensityEstimator.Density(rowArray, rowArray.Length, stepWidth, bandwidth);
 
       Series newSeries = new Series(densitySeriesName);
+      newSeries.Color = series.Color;
       newSeries.ChartType = SeriesChartType.FastLine;
       newSeries.BorderWidth = 2;
@@ -200,4 +216,6 @@
       }
 
+      // densities should be plotted on the second axis (different scale)
+      newSeries.YAxisType = AxisType.Secondary;
       chart.Series.Add(newSeries);
     }
@@ -221,4 +239,11 @@
       UpdateHistogram();
     }
+
+    private void bandwidthNumericUpDown_ValueChanged(object sender, EventArgs e) {
+      if (!suppressUpdate) {
+        UpdateHistogram(decimal.ToDouble(bandwidthNumericUpDown.Value));
+      }
+      suppressUpdate = false;
+    }
   }
 }
Index: branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Analysis/3.3/HeuristicLab.Analysis-3.3.csproj
===================================================================
--- branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Analysis/3.3/HeuristicLab.Analysis-3.3.csproj	(revision 12190)
+++ branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Analysis/3.3/HeuristicLab.Analysis-3.3.csproj	(revision 12247)
@@ -167,5 +167,5 @@
     <Compile Include="Statistics\Fitting\LinearLeastSquaresFitting.cs" />
     <Compile Include="Statistics\Fitting\LogFitting.cs" />
-    <Compile Include="Statistics\NormalDistribution.cs" />
+    <Compile Include="Statistics\KernelDensityEstimator.cs" />
     <Compile Include="Statistics\PairwiseTest.cs" />
     <Compile Include="Statistics\SampleSizeDetermination.cs" />
Index: branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Analysis/3.3/Statistics/KernelDensityEstimator.cs
===================================================================
--- branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Analysis/3.3/Statistics/KernelDensityEstimator.cs	(revision 12247)
+++ branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Analysis/3.3/Statistics/KernelDensityEstimator.cs	(revision 12247)
@@ -0,0 +1,69 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Analysis.Statistics {
+  public static class KernelDensityEstimator {
+    public static double[] Density(double[] x, double mean, double stdDev) {
+      return x.Select(xi => Density(xi, mean, stdDev)).ToArray();
+    }
+
+    public static double Density(double x, double mean, double stdDev) {
+      return (1.0 / (stdDev * Math.Sqrt(2.0 * Math.PI))) *
+                  Math.Exp(-((Math.Pow(x - mean, 2.0)) /
+                             (2.0 * Math.Pow(stdDev, 2.0))));
+    }
+
+    // the scale (sigma) of the kernel is a parameter
+    public static List<Tuple<double, double>> Density(double[] x, int nrOfPoints, double stepWidth, double sigma = 1.0) {
+      // calculate grid for which to estimate the density
+      double[] newX = new double[nrOfPoints];
+      double margin = stepWidth * 2;
+
+      double dataMin = x.Min() - margin;
+      double dataMax = x.Max() + margin;
+      double diff = (dataMax - dataMin) / nrOfPoints;
+      double cur = dataMin;
+      newX[0] = cur;
+      for (int i = 1; i < nrOfPoints; i++) {
+        cur += diff;
+        newX[i] = cur;
+      }
+
+      // for each of the points for which we want to calculate the density
+      // we sum up all the densities of the observed points assuming they are at the center of a normal distribution
+      var y = from xi in newX
+              select (from obsX in x
+                      select Density(xi, obsX, sigma)).Sum();
+
+      return newX.Zip(y, Tuple.Create).ToList();
+    }
+
+    //Silverman's rule of thumb for bandwidth estimation (sigma)
+    public static double EstimateBandwidth(double[] x) {
+      return 1.06 * x.StandardDeviation() * Math.Pow(x.Length, -0.2);
+    }
+  }
+}
Index: branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Clients.Hive.Slave/3.3/Manager/ConfigManager.cs
===================================================================
--- branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Clients.Hive.Slave/3.3/Manager/ConfigManager.cs	(revision 12190)
+++ branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Clients.Hive.Slave/3.3/Manager/ConfigManager.cs	(revision 12247)
@@ -25,4 +25,5 @@
 using System.Linq;
 using System.Management;
+using System.Net.NetworkInformation;
 using HeuristicLab.Clients.Hive.SlaveCore.Properties;
 
@@ -34,4 +35,8 @@
   public class ConfigManager {
     private static ConfigManager instance = null;
+    private const string vmwareNameString = "VMware";
+    private const string virtualboxNameString = "VirtualBox";
+    private const int macLength = 12;
+
     public static ConfigManager Instance {
       get { return instance; }
@@ -179,33 +184,29 @@
     /// </summary>    
     private static Guid GetUniqueMachineIdFromMac() {
-      ManagementClass mgtClass = new ManagementClass("Win32_NetworkAdapterConfiguration");
-      ManagementObjectCollection mgtCol = mgtClass.GetInstances();
-
-      foreach (ManagementObject mgtObj in mgtCol) {
-        foreach (var prop in mgtObj.Properties) {
-          if (prop.Value != null && prop.Name == "MACAddress") {
-            try {
-              //simply take the first nic
-              string mac = prop.Value.ToString();
-              byte[] b = new byte[8];
-              string[] macParts = mac.Split(':');
-              if (macParts.Length == 6) {
-                for (int i = 0; i < macParts.Length; i++) {
-                  b[i + 2] = (byte)((ParseNybble(macParts[i][0]) << 4) | ParseNybble(macParts[i][1]));
-                }
-
-                // also get machine name and save it to the first 4 bytes                
-                Guid guid = new Guid(Environment.MachineName.GetHashCode(), 0, 0, b);
-                return guid;
-              } else
-                throw new Exception("Error getting mac addresse");
-            }
-            catch {
-              throw new Exception("Error getting mac addresse");
-            }
-          }
-        }
-      }
-      throw new Exception("Error getting mac addresse");
+      //try to get a real network interface, not a virtual one 
+      NetworkInterface validNic = NetworkInterface.GetAllNetworkInterfaces()
+                      .FirstOrDefault(x =>
+                                  !x.Name.Contains(vmwareNameString) &&
+                                  !x.Name.Contains(virtualboxNameString) &&
+                                  (x.NetworkInterfaceType == NetworkInterfaceType.Ethernet ||
+                                   x.NetworkInterfaceType == NetworkInterfaceType.GigabitEthernet));
+
+      if (validNic == default(NetworkInterface)) {
+        validNic = NetworkInterface.GetAllNetworkInterfaces().First();
+      }
+
+      string addr = validNic.GetPhysicalAddress().ToString();
+      if (addr.Length != macLength) {
+        throw new Exception("Error generating slave UID: MAC address has to have " + macLength + " digits. Actual MAC address is: " + addr);
+      }
+
+      byte[] b = new byte[8];
+      int j = 2;
+      for (int i = 0; i < macLength; i += 2) {
+        b[j++] = (byte)((ParseNybble(addr[i]) << 4) | ParseNybble(addr[i + 1]));
+      }
+      // also get machine name and save it to the first 4 bytes                
+      Guid guid = new Guid(Environment.MachineName.GetHashCode(), 0, 0, b);
+      return guid;
     }
 
Index: branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.Designer.cs
===================================================================
--- branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.Designer.cs	(revision 12190)
+++ branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.Designer.cs	(revision 12247)
@@ -154,5 +154,4 @@
       this.itemsListView.DoubleClick += new System.EventHandler(this.itemsListView_DoubleClick);
       this.itemsListView.KeyDown += new System.Windows.Forms.KeyEventHandler(this.itemsListView_KeyDown);
-      this.itemsListView.KeyUp += new System.Windows.Forms.KeyEventHandler(this.itemsListView_KeyUp);
       // 
       // imageList
Index: branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.cs
===================================================================
--- branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.cs	(revision 12190)
+++ branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.cs	(revision 12247)
@@ -257,9 +257,5 @@
             Content[item.Index] = null;
         }
-      }
-    }
-
-    protected virtual void itemsListView_KeyUp(object sender, KeyEventArgs e) {
-      if (e.KeyData == (Keys.Control | Keys.C)) {
+      } else if (e.KeyData == (Keys.Control | Keys.C)) {
         if (itemsListView.SelectedItems.Count > 0) {
           var builder = new StringBuilder();
Index: branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.Designer.cs
===================================================================
--- branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.Designer.cs	(revision 12190)
+++ branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.Designer.cs	(revision 12247)
@@ -107,5 +107,4 @@
       this.itemsListView.DoubleClick += new System.EventHandler(this.itemsListView_DoubleClick);
       this.itemsListView.KeyDown += new System.Windows.Forms.KeyEventHandler(this.itemsListView_KeyDown);
-      this.itemsListView.KeyUp += new System.Windows.Forms.KeyEventHandler(this.itemsListView_KeyUp);
       // 
       // imageList
Index: branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs
===================================================================
--- branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs	(revision 12190)
+++ branches/HeuristicLab.DatasetRefactor/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs	(revision 12247)
@@ -242,8 +242,5 @@
           }
         }
-      }
-    }
-    protected virtual void itemsListView_KeyUp(object sender, KeyEventArgs e) {
-      if (e.KeyData == (Keys.Control | Keys.C)) {
+      } else if (e.KeyData == (Keys.Control | Keys.C)) {
         if (itemsListView.SelectedItems.Count > 0) {
           var builder = new StringBuilder();
